Scriptname DBM_PickyBeaconAddonScript extends ObjectReference  
{Extends functionality of Picky's Beacon.}

;;BEACON CONTROLS
Message Property DBM_PickyBeaconAddonMessage1 Auto
{First travel selector menu}
Message Property DBM_PickyBeaconAddonMessage2 Auto
{Second travel selector menu}
ObjectReference Property EngineLink Auto
{Beacon attached to engine for recieving command}
ObjectReference Property LockedHatch Auto
{Interior hatch that is locked.}

;;MAP FLAGS FOR REMOTE ACTIVATION - Interacts with DBM_NavigateScript
ObjectReference Property AmberCreekFlag Auto
{Amber Creek Falskaar Flag}
ObjectReference Property FalskaarDocksFlag Auto
{Falskaar Docks Flag}
ObjectReference Property BenEraiFlag Auto
{Ben Erai Hammerfell Flag}
ObjectReference Property LullMorFlag Auto
{Lull Mor Flag}
ObjectReference Property HelgenFlag Auto
{Helgen Reborn Flag}
ObjectReference Property TFCFlag Auto
{The Forgotten City Flag}

;;FORMLISTS - Interacts with DBM_AirshipScript
ObjectReference Property DBM_AirshipHelm Auto
{Solitude Helm to activate remotely}
FormList Property ShipList Auto
{All ships}
FormList Property CurShip Auto
{Current ship formlist}
FormList Property CurPlayerMark Auto
{Current player marker formlist - check distance from when activating}
GlobalVariable Property ReadyState Auto
{Ready state to lockout additional controls.}

;;VARIABLES
ObjectReference Flag ;Flag to activate remotely
String LocationName ;Name of location for debugs
ObjectReference ActiveShip ;Marker to measure distance with
Int Distance ;Distance variable

Event OnEquipped(Actor akPlayer)
if akPlayer == Game.GetPlayer()
		if !EngineLink.IsDisabled() && ReadyState.Value == 0 || ReadyState.Value == 1 ;The Engine Link Beacon is installed.
		int TravelChoice = DBM_PickyBeaconAddonMessage1.Show()
			if TravelChoice == 0
				;Close the menu
			elseif TravelChoice == 1 ;Helgen
				ReadyState.Value = 2
				Flag = HelgenFlag
				Flag.Activate(Game.GetPlayer())
				MoveDevAveza()
			elseif TravelChoice == 2 ;Ben Erai
				ReadyState.Value = 2
				Flag = BenEraiFlag
				Flag.Activate(Game.GetPlayer())
				MoveDevAveza()
			elseif TravelChoice == 3 ;The Forgotten City
				ReadyState.Value = 2
				Flag = TFCFlag
				Flag.Activate(Game.GetPlayer())
				MoveDevAveza()
			elseif TravelChoice == 4 ;Lull Mor
				ReadyState.Value = 2
				Flag = LullMorFlag
				Flag.Activate(Game.GetPlayer())
				MoveDevAveza()
			elseif TravelChoice == 5 ;Next
				TravelChoice = DBM_PickyBeaconAddonMessage2.Show() ;second options screen
				if TravelChoice == 0 ;Previous
					TravelChoice = DBM_PickyBeaconAddonMessage1.Show()
				elseif TravelChoice == 1 ;Amber Creek
					ReadyState.Value = 2
					Flag = AmberCreekFlag
					Flag.Activate(Game.GetPlayer())
					MoveDevAveza()
				elseif TravelChoice == 2 ;Falskaar Docks
					ReadyState.Value = 2
					Flag = FalskaarDocksFlag
					Flag.Activate(Game.GetPlayer())
					MoveDevAveza()
				elseif TravelChoice == 3 ;Cancel
					;
				endif
			endif
		elseif !EngineLink.IsDisabled() && ReadyState.Value >= 2
		GetLocName()
		debug.messagebox("The airship is currently in transit. I should wait before moving it again.")
	else
		debug.MessageBox("When I hold the beacon I can feel a link to another device, but it does nothing.")
	endif
EndIf
EndEvent

Function MoveDevAveza()
	Utility.Wait(0.5) ;Extra Wait to allow flag activation to finish
	GetLocName()
	Int ShipIndex = ShipList.GetSize()
	WHILE ShipIndex
		ShipIndex -= 1
		ActiveShip = ShipList.GetAt(ShipIndex) as ObjectReference
		if !ActiveShip.IsDisabled()
		Distance = Game.GetPlayer().GetDistance(ActiveShip) as Int
		While Distance != 0 && Distance < 1500
			Utility.Wait(2)
			Distance = Game.GetPlayer().GetDistance(ActiveShip) as Int
			;Debug.Trace("DBM Beacon Script - Distance from Airship is " + Distance + "")
			Debug.Notification("I should probably stand clear of the airship as it departs!")
		EndWhile
		endif
	ENDWHILE
	Utility.Wait(0.5) ; pause before activating helm.
	LockedHatch.Enable()
	DBM_AirshipHelm.Activate(Game.GetPlayer())
	Utility.WaitGameTime(2)
	debug.Notification("The Dev Aveza has arrived in " + LocationName + "")
	LockedHatch.Disable()
	ReadyState.Value = 0 ;Reset control ready for reuse
	CurShip.Revert()
	CurPlayerMark.Revert()
EndFunction

Function GetLocName()
	LocationName = Flag.GetBaseObject().GetName() ;SKSE Function
EndFunction